//Fortran: EQUIVALENCE ( ... )
Unit AA01R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function AA01R(Z :Complex): Real;

implementation

function AA01R(Z :Complex): Real;
var
H :Real;
ZZ :Complex;
T :Array [0..1] of Real;
label
_1,_2,_3,_4,_5;
begin
{ Result -    AA01R  FORTRANe }
ZZ := Z;
T[0] := Abs(T[0]);
T[1] := Abs(T[1]);
if ( T[0] = 0.0 ) and ( T[1] = 0.0 ) 
 then goto _4;
if ( T[0] < T[1] ) 
 then goto _1;
goto _2;
_1:
H := T[0];
T[0] := T[1];
T[1] := H;
_2:
if ( T[1] = 0.0 ) 
 then goto _3;
Result := T[0]*Sqrt(1.0+IntPower(T[1]/T[0],2));
goto _5;
_3:
Result := T[0];
goto _5;
_4:
Result := 0.0;
_5:
exit;
end;

end.
